c PostScript implementation of window,plot,page, pen, quadrilaterals.
c Changes made for compressive version of visct /gan/ 11/21/95
c unix system dependent subroutines!!!!
c 5.5: Added a subroutine quads to plot strain on the right panel
* ____________________________________________________________________ *

      subroutine window(x1,x2,y1,y2)
* ____________________________________________________________________ *

      character*26 ctime
      integer*4 time
c
      real x1,x2,y1,y2
      now = time
c     time(0)
c encapsulated header, 8. by 10.5
      write(8,'(a)')'%!PS-Adobe-2.0  EPSF-1.2'
      write(8,'(a)')'%%BoundingBox: 18 18 592 774'
      write(8,'(a)')'%%DocumentFonts: Helvetica'
c      write(8,'(a)')'%%Creator: argyre.gsfc.nasa.gov'
      write(8,'(a)')'%%Creator: LGJ Montesi after GA Neumann'
*5.3: ctime is a problem for gfortran compiler on some linux distributions
c      write(8,'(a,a24)')'%%Created ',ctime(now)
      write(8,'(a)')'%%EndComments'
      write(8,'(a)')'% Begin header'
      write(8,'(a)')'612 36 translate 90 rotate 0 setlinewidth'
      write(8,'(a)')'/Helvetica findfont 14 scalefont setfont'
c frequently used operators
      write(8,'(a)')'/d {rlineto} bind def'
      write(8,'(a)')'/r {rmoveto} bind def'
      write(8,'(a)')'/l {lineto} bind def'
      write(8,'(a)')'/m {stroke moveto} bind def'
      scalex=720./abs(x2-x1)
      scaley=540./abs(y2-y1)
      scalex= min(scalex,scaley)
      scaley= scalex
c move y downward by a y2 displacement, while scale bar stays put
      ioff = 540.*y2/abs(y2-y1)
c negative scale is a kludge that plots increasing depths downward 
      if(y1.gt.y2) scaley=-scaley
      write(8,'(a)')'% scale factor'
      write(8,88) scalex, scaley
88    format('/xscale {',f10.3,'} def'/'/yscale {',f10.3,'} def')
      write(8,'(a)')'% origin of model (0.,0)'
      write(8,'(a)')'/x {360} def'
      write(8,'(a,i3,a)')'/y {',540+ioff,'} def'
      write(8,'(a)')'% top of 15-pt-thick colored scale bars'
      write(8,'(a)')'/yt {540} def'
      write(8,'(a)')'gsave % landscape orientation'
 
c the rest of this stuff is for coloring in boxes with simple commands,
c which are defined by letters below. Arrays are defined for color which
c contain hue, saturation and brightness.  These can be changed after the
c plot file is created, of course.

c The box is drawn with '{x1} {y1} m {x2} {y2} l {x3} {y3} l {x4} {y4} l'
c Then the color number in the range [0-40} is written out, followed by
c a letter 'f' for stress, 'c' for coulomb failure stress, 'g' for strainrate 
c saturation index for colorscales, 0 for grayscale, 1 for intense color

      write(8,'(a/a/a/a)')
     *'/stress',
     *'[0 0 0 0 .01 .02 .04 .06 .08 .10 .12 .14 .16 .18 .2 .22 .24 .26'
     *,' .28 .3 .33 .36 .38 .4 .42 .44 .46 .48 .5 .52 .54 .56 .58 .59'
     *,'.6 .61 .62 .63 .64 .65 .66] def'

c make function for stress
      write(8,'(a)')
     *  '/f {closepath gsave dup stress exch get exch sat exch get 1
     * sethsbcolor fill grestore} bind def'

      write(8,'(a/a/a)')
     *'/coulomb',
     *'[.8 .75 .72 .7 .58 .55 .53 .5 .48 .45 .42 .4 .38 .35 .33 .32 .31'
     *,'.4 .38 .36 .34 .3 .2 .1 .1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0] def'
c function for stress in coulomb failure regime
c default is same colors
      write(8,'(a)')'/c {f} bind def'
c alternative is shaded
      write(8,'(a)')
     * '/c {closepath gsave coulomb exch get setgray fill grestore} def'
c
       write(8,'(a/a/a)')
     *'/sat',
     *'[0 .12 .2 .32 .4 .5 .62 .75 .87 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1'
     *,' 1 1 1 1 1 1 1 1 1 1 1 .9 .8 .75 .7 .6 .5 .4 .3 .2 .1 0] def'

      write(8,'(a/a/a/a)')
     *'/strain [',
     *'.80 .78 .76 .74 .72 .70 .68 .66 .64 .62 .60 .58 .56 .54 .52 .50',
     *'.45 .40 .35 .30 .25 .22 .20 .19 .18 .17 .16 .15 .14 .13 .12 .11',
     *'.10 .08 .06 .04 .02 .00 .00 .00 .00 .00 0 0 0 0 0 0 0 0 0 0] def'
c---|----1----|----2----|----3----|----4----|----5----|----6----|----7----|----8
c function for decibels of strain rate
      write(8,'(a)')
     * '/g {closepath gsave dup strain exch get exch sat exch get 1
     * sethsbcolor fill grestore} bind def'
c function for effective stress
c     write(8,'(a)')  '/e {pop} def'
      write(8,'(a)')
     *  '/e {gsave 40 div neg 1 add setgray fill grestore} bind def'
      end


* ____________________________________________________________________ *

      subroutine  page(ip,iprob)
* ____________________________________________________________________ *

      character*26 ctime,today
      integer*4 time
      logical init
      save init
      character*8 arg
      character*10 arg1,arg2
      data init/.false./,arg1 /" "/,arg2/" "/
c don't close plot unless opened!
      if(init.and.ip.eq.0) then
         write(8,*)'stroke grestore copypage'
         write(8,*)'%%EOF'
      else

         if (init) write(8,*)'stroke grestore copypage erasepage'
         init = .true.
         write(8,'(a,i3)')'%%Page: ?',ip
c get command line
c        call getarg(0,arg)
c        if(iargc().gt.0) call getarg(1,arg1)
c        if(iargc().gt.1) call getarg(2,arg2)
c get unix time
c        now = time(0)
c       today=ctime(now)
c original (landscape) coordinate system
c        write(8,'(a,a,a,a,a24,a)')
c    &  'x y 36 add m( ',arg,arg1,arg2,today,')show'

c strain rate scale bar
         write(8,'(a)')'gsave 0 yt translate 0.75 dup scale'
         write(8,'(a)')'140 18 m (log)show 0 -4 r .8 dup scale (10)show' 
         write(8,'(a)')'1.25 dup scale 0 4 r ((strain rate)) show'
	 do i=0,39
            write(8,'(2i4,a)') i,12*i,' 0 m 0 -20 d 12 0 d 0 20 d g'
            if (mod(i,10).eq.0) 
     &           write(8,'(a,i2,a)')'-8 4 r (',i/10-2,') show'
         enddo
         write(8,'(a,i2,a)')'4 4 r (',1,') show'
         write(8,'(a)')'stroke grestore'
         if (iprob.eq.0) then
c stress scale bar
            write(8,'(a)')'gsave x 6 add yt translate 0.75 dup scale'
            write(8,'(a)')'140 18 m (stress, MPa) show'
            do i=0,39
               write(8,'(2i4,a)') i,12*i,' 0 m 0 -20 d 12 0 d 0 20 d f'
               if (mod(i,10).eq.0) 
     &              write(8,'(a,i3,a)')'-8 4 r (',10*i,') show'
            enddo
         else
c 5.3: strain or viscosity scale bar
            if (iprob.eq.3) then
             write(8,'(a)')'gsave x 6 add yt translate 0.75 dup scale'
         write(8,'(a)')'140 18 m (log)show 0 -4 r .8 dup scale (10)show' 
               write(8,'(a)')'1.25 dup scale 0 4 r (( strain )) show'
               do i=0,39
              write(8,'(2i4,a)') i,12*i,' 0 m 0 -20 d 12 0 d 0 20 d g'
                  if (mod(i,10).eq.0) 
     &                 write(8,'(a,i3,a)')'-8 4 r (',i/10-2,') show' 
               enddo
            else
               write(8,'(a)')'gsave x 6 add yt translate 0.75 dup scale'
         write(8,'(a)')'140 18 m (log)show 0 -4 r .8 dup scale (10)show' 
               write(8,'(a)')'1.25 dup scale 0 4 r (( viscosity )) show'
               do i=0,39
                write(8,'(2i4,a)') i,12*i,' 0 m 0 -20 d 12 0 d 0 20 d f'
                  if (mod(i,10).eq.0) 
     &                 write(8,'(a,i3,a)')'-8 4 r (',i/5+18,') show'
               enddo
            endif
         endif
         write(8,'(a)')'stroke grestore'
      endif
      end


* ____________________________________________________________________ *

      subroutine  pagelast(ip)
* ___________________________________________________________________ *

      character*26 ctime,today
      integer*4 time
      logical init
      save init
      character*8 arg
      character*10 arg1,arg2
      data init/.false./,arg1 /" "/,arg2/" "/
c don't close plot unless opened!
      if(init.and.ip.eq.0) then
         write(8,*)'stroke grestore copypage'
         write(8,*)'%%EOF'
      else
         if (init) write(8,*)'stroke grestore copypage erasepage'
         init = .true.
         write(8,'(a,i3)')'%%Page: ?',ip
c get command line
c        call getarg(0,arg)
c        if(iargc().gt.0) call getarg(1,arg1)
c        if(iargc().gt.1) call getarg(2,arg2)
c get unix time
c        now = time(0)
c       today=ctime(now)
c original (landscape) coordinate system
c        write(8,'(a,a,a,a,a24,a)')
c    &  'x y 36 add m( ',arg,arg1,arg2,today,')show'

c normal stress scale bar
         write(8,'(a)')'gsave 0 yt translate 0.75 dup scale'
         write(8,'(a)')'140 18 m  (normal stress, MPa) show'
	 do i=0,39
            write(8,'(2i4,a)') i,12*i,' 0 m 0 -20 d 12 0 d 0 20 d f'
            if (mod(i,10).eq.0) 
     &           write(8,'(a,i3,a)')'-8 4 r (',10*i,') show'
         enddo
c         write(8,'(a,i2,a)')'4 4 r (',1,') show'
         write(8,'(a)')'stroke grestore'
c shear stress scale bar
         write(8,'(a)')'gsave x 6 add yt translate 0.75 dup scale'
         write(8,'(a)')'140 18 m (shear stress, MPa) show'
         do i=0,39
            write(8,'(2i4,a)') i,12*i,' 0 m 0 -20 d 12 0 d 0 20 d f'
            if (mod(i,10).eq.0) 
     &           write(8,'(a,i3,a)')'-8 4 r (',10*i,') show'
         enddo
         write(8,'(a)')'stroke grestore'
      endif
      end

* ____________________________________________________________________ *
*                                                                      *
      subroutine quadnorm(x,y,tau,fl)
*     fill quadrilaterals on right with colored shear stress (tau)     *
* ____________________________________________________________________ *
      real*8 tau
      integer fl
      real*4 x(9),y(9)
c scale to units of MPa
c      print *,fl
      t=tau*1e-6
c convert to shades
      it = abs(t)
      it=min(40,it)
      call plot(-x(1),y(1),3)
      do i=2,4
         call plot(-x(i),y(i),2)
      enddo
c fill with shade

      if(fl.ge.0.) then
         write(8,'(i2,a)') it,' f'
      else
         write(8,'(i2,a)') it,' c'
      endif
      end
* ____________________________________________________________________ *
*                                                                      *
      subroutine quadr(x,y,tau)
*     fill quadrilaterals on right with colored stress (tau)           *
* ____________________________________________________________________ *
      real*8 tau
      real*4 x(9),y(9)
c scale to units of MPa
      t=tau*1e-6
c convert to shades
      it = abs(t)
      it=min(40,it)
      call plot(x(1),y(1),3)
      do i=2,4
         call plot(x(i),y(i),2)
      enddo
c fill with shade

      if(tau.ge.0.) then
         write(8,'(i2,a)') it,' f'
      else
         write(8,'(i2,a)') it,' c'
      endif
      end
* ____________________________________________________________________ *
*                                                                      *
      subroutine quadshear(x,y,tau,fl)
*     fill quadrilaterals on right with colored shear stress (tau)     *
* ____________________________________________________________________ *
      real*8 tau
      integer fl
      real*4 x(9),y(9)
c scale to units of MPa
      t=tau*1e-6
c convert to shades
      it = abs(t)
      it=min(40,it)
      call plot(x(1),y(1),3)
      do i=2,4
         call plot(x(i),y(i),2)
      enddo
c fill with shade

      if(tau.ge.0.) then
         write(8,'(i2,a)') it,' f'
      else
         write(8,'(i2,a)') it,' c'
      endif
      end
* ____________________________________________________________________ *
*                                                                      *
      subroutine quadv(x,y,c1)
*     fill quadrilaterals on right with colored viscocity (c1)           *
* ____________________________________________________________________ *
      real*8 c1
      real*4 x(9),y(9)

c convert to shades
      it = max((log10(abs(c1))-18.)*5.,0.)
      it=min(40,it)
      call plot(x(1),y(1),3)
      do i=2,4
         call plot(x(i),y(i),2)
      enddo
c fill with shade

      if(c1.ge.0.) then
         write(8,'(i2,a)') it,' f'
      else
         write(8,'(i2,a)') it,' c'
      endif
      end

* ____________________________________________________________________ *
*                                                                      *
      subroutine quadl(x,y, e2)
*     fill quadrilaterals on left with colored strainrate (e2)         *
* ____________________________________________________________________ *
      real*8 e2
      real*4 x(9),y(9)
c convert to decibels relative to 10**-3
      e = abs(e2)
      is=max(20.+10.*log10(e),0.)
      is=min(40,is)
c flip sign of u for left side
      call plot(-x(1),y(1),3)
      do i=2,4
         call plot(-x(i),y(i),2)
      enddo
c closepath gsave setgray fill grestore stroke
      write(8,'(i2,a)') is,' g'
      end

*5.3: quads plots strain on right

* ____________________________________________________________________ *
*                                                                      *
      subroutine quads(x,y, str2)
*     fill quadrilaterals on right with colored strain (str2)         *
* ____________________________________________________________________ *
      real*8 str2
      real*4 x(9),y(9)
c convert to decibels relative to 10**-3
      e = abs(str2)
      is=max(20.+10.*log10(e),0.)
      is=min(40,is)
c no sign flip for x (right display)
      call plot(x(1),y(1),3)
      do i=2,4
         call plot(x(i),y(i),2)
      enddo
c closepath gsave setgray fill grestore stroke
      write(8,'(i2,a)') is,' g'
      end

* ____________________________________________________________________ *
*                                                                      *
      subroutine plot(x,y,ipen)
* ____________________________________________________________________ *
C NOTE THAT WE CONVERT TO KM IN THE FORMAT -3P
      if(ipen.eq.3) then
	 write(8,'(-3p,2f9.3,a)') x,y,' m'
      else if (ipen.eq.2) then
	 write(8,'(-3p,2f9.3,a)') x,y,' l'
      else if (ipen.eq. 1) then
	 write(8,'(-3p,2f9.3,a)') x,y,' r'
      else
	 write(8,'(-3p,2f9.3,a)') x,y,' d'
      endif
      end

* ____________________________________________________________________ *
*                                                                      *
      subroutine flowl(x,y,u)
* left side flow vectors (-x)                                          *
* ____________________________________________________________________ *
      parameter(factor=0.5e+13)
      real*8 u(2)
      real*8 x,y
      xx = x
      yy = y
      call plot(-xx,yy,3)
      xx = factor*u(1)
      yy = factor*u(2)
      call plot(-xx, yy,  0)
      end

* ____________________________________________________________________ *
*                                                                      *
      subroutine flowr(x,y,u)
* right side flow vectors (+x)                                         *
* ____________________________________________________________________ *
      parameter(factor=1.0e+00)
      real*8 u(2)
      real*8 x,y
      xx = x
      yy = y
      call plot(xx,yy,3)
      xx =xx+factor*u(1)
      yy =yy+factor*u(2)
      call plot(xx, yy,  2)
      end


* ____________________________________________________________________ *
*                                                                      *
      subroutine pen(kpen)
* ____________________________________________________________________ *
      write(8,'(i4,a)') kpen,' yscale div stroke setlinewidth'
      end
